package main

import (
	"fmt"
	"time"
)

func main() {
	fmt.Println("When’s Thursday?") // เมื่อไหร่เป็นวันพฤหัสบดี
	today := time.Now().Weekday()   // เก็บค่าวันนี้คือวันอังคารไว้ในตัวแปร today
	switch time.Thursday {          // เทียบกับ Thursday
	case today + 0: // วันนี้ Tuesday
		fmt.Println("Today.")
	case today + 1: // วันพุธ Wednesday
		fmt.Println("Tomorrow.")
	case today + 2: // วันพฤหัสบดี Thursday
		fmt.Println("In two days.")
	default: // ไม่ตรงกับวันใดเลย
		fmt.Println("Too far away.")
	}
}
