package main

import "fmt"

func seq() func() int { // ประกาศฟังก์ชันแม่ชื่อ seq มีการคืนค่าด้วยฟังก์ชันและส่งค่ากลับ
	x := 0              // ประกาศตัวแปร x ในฟังก์ชันแม่
	return func() int { // คืนค่าด้วยฟังก์ชันลูกที่ไม่มีชื่อและส่งค่ากลับด้วย int
		x++      // เพิ่มค่าในตัวแปร x ที่อยู่ในฟังก์ชันแม่ขึ้น 1
		return x // คืนค่าตัวแปร x ออกไป
	}
}

func main() {
	num := seq()       // ประกาศตัวแปร num เป็นอินสแตนซ์ของฟังก์ชัน seq
	fmt.Println(num()) // พิมพ์แสดงผลลัพธ์จากการเรียกใช้ num
	fmt.Println(num()) // พิมพ์แสดงผลลัพธ์จากการเรียกใช้ num
	fmt.Println(num()) // พิมพ์แสดงผลลัพธ์จากการเรียกใช้ num
}
