package main

import "fmt"

type Car struct { // สร้างสตรักต์ Car
	name        string
	door, price int
}
type EV struct { // สร้างสตรักต์ EV เป็น Embed Struct
	feature         string
	battery, ranges int
	Car             // ฝังสตรักต์ Car เป็นฟิลด์ไม่มีชื่อ
}

func (c Car) Show() { // สร้างเมธอด Show กำหนด Reciever ด้วยสตรักต์ Car
	fmt.Printf("Car name: %s, Door : %d, Price :  %d", c.name, c.door, c.price)
}
func (e EV) Ranges() float64 { // สร้างเมธอด Ranges กำหนด Reciever ด้วยสตรักต์ EV
	return float64(e.ranges) * 1.60934
}

func main() {
	m := EV{ // สร้างตัวแปร m ชนิดข้อมูล EV พร้อมกำหนดค่าเริ่มต้น
		feature: "FSD",
		battery: 250,
		ranges:  272,
		Car: Car{
			name:  "Tesla Model 3 RWD",
			door:  3,
			price: 1759000,
		},
	}
	fmt.Printf("\nName : %s", m.Car.name) // อ่านชื่อรุ่นรถยนต์ผ่านชื่อสตรักต์ Car
	fmt.Printf("\nName : %s", m.name)     // อ่านชื่อรุ่นรถยนต์จากตัวแปรได้โดยตรง
	fmt.Println()
	m.Car.Show() // เรียกใช้เมธอดของ Car โดยอ้างผ่านชื่อของสตรักต์ Car
	fmt.Println()
	m.Show()                                   // เรียกใช้เมธอดของ Car จากตัวแปร ได้โดยตรง
	fmt.Printf("\nRange : %f kms", m.Ranges()) // เรียกใช้เมธอดของ EV
}
