package main

import "fmt"

type Rectangle struct { // สร้างชนิดข้อมูล Rectangle ด้วยโครงสร้างแบบสตรักต์
	width, length int // กำหนดฟิลด์สมาชิกความกว้างและความยาว
}

// เมธอด scale ปรับเปลี่ยนคุณลักษณะของรูปสี่เหลี่ยมผืนผ้า
func (r *Rectangle) scale(m int) {
	r.width = r.width * m
	r.length = r.length * m
}

// เมธอด Area คำนวณพื้นที่รูปสี่เหลี่ยมผืนผ้า
func (r *Rectangle) Area() int {
	return r.width * r.length
}
func main() {
	rec := &Rectangle{10, 5} //เก็บค่าสี่เหลี่ยมในหน่วยความจำและตำแหน่งในพอยน์เตอร์ rec
	//แสดงคุณลักษณะของสี่เหลี่ยมก่อนปรับขนาด
	fmt.Printf("Before scale width : %d, length : %d \n", rec.width, rec.length)
	fmt.Printf("Area before scale: %d\n", rec.Area()) //พื้นที่สี่เหลี่ยมก่อนปรับขนาด		rec.scale(2)							//ปรับขนาดสี่เหลี่ยม 2 เท่า
	//แสดงคุณลักษณะของสี่เหลี่ยมหลังปรับขนาด
	fmt.Printf("After scale width : %d, length : %d \n", rec.width, rec.length)
	fmt.Printf("Area After scale: %d\n", rec.Area()) //พื้นที่สี่เหลี่ยมหลังปรับขนาด
}
