package main

import "fmt"

type ProductDes interface { // สร้างชนิดข้อมูล ProductDes ในรูปของอินเทอร์เฟซ
	display()
}

type ProductStock interface { // สร้างชนิดข้อมูล ProductDes ในรูปของอินเทอร์เฟซ
	ProductDes
	stockValue()
}
type product struct { // สร้างสตรักต์ product
	name     string
	category string
	price    int
	stock    int
}

func (d product) display() { // สร้างเมอด display แสดงข้อมูลสินค้า
	fmt.Println("Product Name : ", d.name)
	fmt.Println("Product Category : ", d.category)
	fmt.Println("Product Price : ", d.price)
	fmt.Println("Product Stock : ", d.stock)
}
func (s product) stockValue() { // สร้างเมอด stockValue แสดงมูลค่าสินค้าค้างสต็อก
	sv := s.price * s.stock
	fmt.Printf("%s has Stock Value : %d\n", s.name, sv)
}
func main() {
	var pd ProductStock = product{"xPad 10", "Tablet", 18000, 8} //สร้างอินเทอร์เฟสเก็บสตรักต์
	pd.display()                                                 // เรียกใช้เมธอด display จากอินเทอร์เฟส ProductDes
	pd.stockValue()                                              // เรียกใช้เมธอด stockValue จากอินเทอร์เฟส ProductStock
}
