package main

import (
	"fmt"
	"time"
)

func main() {
	ch := make(chan int) // ประกาศตัวแปร ch ชนิดข้อมูลแชนเนล
	for i := 0; i < 4; i++ {
		go hello(i, ch) // สร้าง Goroutine พร้อมส่งค่าลำดับ i และแชลเนล ch
	}
	for i := 0; i < 4; i++ {
		id := <-ch                                    // รับค่าจากแชนเนล ch และกำหนดไว้ใน id
		fmt.Println("Receive value from channel", id) // แสดงว่ารับค่าของ Goroutine ตัวใด
	}
}
func hello(n int, ch chan int) { // ฟังก์ชัน Hello รับค่าลำดับของ Goroutine และแชนเนล
	for i := 0; i < 4; i++ {
		time.Sleep(500 * time.Millisecond) // หน่วงเวลาให้ Goroutine ทำงาน
		fmt.Println("send value to channel", n)
		ch <- n // ส่งค่าลำดับ Goroutine จาก n ไปยังแชนเนล c
	}
}
