package main

import (
	"fmt"
)

func main() {
	var x, y = 6, 3 // ประกาศตัวแปรเป็นเลขจำนวนเต็ม

	// แสดงค่าในตัวแปรเป็นเลขฐานสอง และฐานสิบ
	fmt.Printf("Binary  x = %04b, y = %04b\n", x, y)
	fmt.Printf("Decimal x = %d,    y = %d\n", x, y)

	// แสดงการใช้ตัวดำเนินการบิตข้อมูลด้วย &, |, ^, &^ และ >> กับตัวแปร
	fmt.Printf("(x AND y) binary = %04b  decimal = %d,\n", x&y, x&y)
	fmt.Printf("(x OR y) binary = %04b  decimal = %d,\n", x|y, x|y)
	fmt.Printf("(x XOR y) binary = %04b  decimal = %d,\n", x^y, x^y)
	fmt.Printf("(x AND NOT y) binary = %04b  decimal = %d,\n", x&^y, x&^y)
	fmt.Printf("(x right shift 2) binary = %04b  decimal = %d,\n", x>>2, x>>2)

}
