package main

import (
	"fmt"
	"math"
)

type Circle struct { // ประกาศตัวแปร Circle เพื่อกำหนดรัศมีวงกลม
	radius float64
}
type Rectangle struct { // ประกาศตัวแปร Rectngle เพื่อกำหนดความกว้างและยาว
	length int
	width  int
}

func (c Circle) Area() float64 { // เมธอดหาพื้นที่วงกลม
	return math.Pi * math.Pow(c.radius, 2)
}

func (r Rectangle) Area() int { // เมธอดหาพื้นที่สี่เหลี่ยมผืนผ้า
	return r.length * r.width
}
func (r Rectangle) perimeter() int { // เมธอดหาความยาวรอบสี่เหลี่ยมผืนผ้า
	return 2 * (r.length + r.width)
}
func (c Circle) perimeter() float64 { // เมธอดหาความยาวเส้นรอบวงกลม
	return 2 * math.Pi * c.radius
}
func main() {
	rec := Rectangle{ // กำหนดความกว้างและยาวของสี่เหลี่ยมผืนผ้า
		length: 10,
		width:  5,
	}
	cir := Circle{radius: 10} // กำหนดความรัศมีวงกลม

	// เรียกเมธอดหาพื้นที่สี่เหลี่ยมผืนผ้าและเส้นรอบวง
	fmt.Printf("Area of rectangle %d\n", rec.Area())
	fmt.Printf("Perimeter of rectangle %d\n", rec.perimeter())
	// เรียกเมธอดหาพื้นที่วงกลมและเส้นรอบวง
	fmt.Printf("Area of circle %.2f\n", cir.Area())
	fmt.Printf("Perimeter of circle %.2f ", cir.perimeter())
}
