package main

import "fmt"

type DivZero struct {
	str string
}

func (e *DivZero) Error() string {
	return fmt.Sprint(e.str)
}
func divide(x int, y int) (int, error) {
	if y == 0 {
		return -1, &DivZero{"Cannot divide by 0!"}
	}
	return x / y, nil
}
func main() {
	answer, err := divide(8, 0)
	if err != nil {
		fmt.Println(err)
	} else {
		fmt.Println(answer)
	}
}
