package main

import "fmt"

type ProductDetails interface { // สร้างอินเทอร์เฟส ProductDetails
	details()
}
type ProductStock interface { // สร้างอินเทอร์เฟส ProductStock
	checkStock()
}
type product struct { // สร้างสตรักต์ product
	name     string
	category string
	price    int
	stock    int
}

func (d product) details() { // สร้างเมธอด details ใช้ Receiver ด้วย product
	fmt.Println("Product Name : ", d.name)
	fmt.Println("Product Category : ", d.category)
	fmt.Println("Product Price : ", d.price)
}
func (s product) checkStock() { // สร้างเมธอด checkStock ใช้ Receiver ด้วย product
	if s.stock <= 10 {
		fmt.Printf("There are %d, almost out of stock.", s.stock)
	} else {
		fmt.Printf("There are %d in stock.", s.stock)
	}
}
func main() {
	p := product{"xPad 10", "Tablet", 18000, 8} // ประกาศตัวแปร  p ด้วยสตรักต์ product
	var pd ProductDetails = p                   // ประกาศตัวแปรอินเทอร์เฟส pd เชื่อมกับสตรักต์
	pd.details()                                // ใช้อินเทอร์เฟส pd เรียกใช้เมธอด detail
	var ps ProductStock = p                     // ประกาศตัวแปรอินเทอร์เฟส ps เชื่อมกับสตรักต์
	ps.checkStock()                             // ใช้อินเทอร์เฟส ps เรียกใช้เมธอด checkStock
}
