package main

import (
	"fmt"
	"time"
)

func main() {
	go HelloOne()
	go HelloTwo()
	time.Sleep(3000 * time.Millisecond)
	fmt.Println("main function")
}
func difftime() int64 { // ฟังก์ชันแสดงระยะเวลา(หน่วยเป็นมิลลิวินาที)
	return time.Now().UnixNano() / int64(time.Millisecond)
}
func HelloOne() {
	for i := 1; i <= 5; i++ {
		start := difftime() // เวลาเริ่มต้นทำงานของโปรแกรม
		time.Sleep(250 * time.Millisecond)
		end := difftime() // ช่วงหน่วงเวลาและรันคำสั่งในฟังก์ชันในแต่ละลูป
		// แสดงผลการรันฟังก์ชัน HelloOne และเวลาที่ใช้
		fmt.Printf("No.%d %v Duration (ms) : %d\n", i, "Run HelloOne", end-start)
	}
}
func HelloTwo() {
	for i := 1; i <= 5; i++ {
		start := difftime()
		time.Sleep(400 * time.Millisecond)
		end := difftime()
		// แสดงผลการรันฟังก์ชัน HelloTwo และเวลาที่ใช้ในแต่ละลูป
		fmt.Printf("No.%d %v Duration (ms) : %d\n", i, "Run HelloTwo", end-start)
	}
}
